OGRE-Next: Ogre::D3D11HLSLProgram Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Member Functions | Public Attributes | List of all members
Ogre::D3D11HLSLProgram Class Referencefinal

Specialization of HighLevelGpuProgram to provide support for D3D11 High-Level Shader Language (HLSL). More...

`#include <OgreD3D11HLSLProgram.h>`

Inheritance diagram for Ogre::D3D11HLSLProgram:
[legend]

## Classes
class | CmdColumnMajorMatrices
| Command object for setting matrix packing in column-major order. More...
class | CmdEnableBackwardsCompatibility
| Command object for setting backwards compatibility. More...
class | CmdEntryPoint
| Command object for setting entry point. More...
class | CmdPreprocessorDefines
| Command object for setting macro defines. More...
class | CmdTarget
| Command object for setting target assembler. More...

## Public Member Functions
| D3D11HLSLProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual, ManualResourceLoader *loader, D3D11Device &device)
| ~D3D11HLSLProgram () override
void | buildConstantDefinitions () const override
| Build the constant definition map, must be overridden.
void | CreateComputeShader ()
void | CreateDomainShader ()
void | CreateGeometryShader ()
void | CreateHullShader ()
GpuProgramParametersSharedPtr | createParameters () override
| Overridden from GpuProgram.
void | CreatePixelShader ()
void | CreateVertexShader ()
bool | getColumnMajorMatrices () const
| Gets whether matrix packed in column-major order.
const String & | getCompatibleTarget () const
| Gets the shader target promoted to the first compatible, e.g.
ID3D11ComputeShader * | getComputeShader () const
void | getConstantBuffers (ID3D11Buffer **buffers, UINT &outSlotStart, UINT &outNumBuffers, GpuProgramParametersSharedPtr params, uint16 variabilityMask)
| buffers must have a capacity of 2, i.e. ID3D11Buffer *buffers[2];
ID3D11DomainShader * | getDomainShader () const
bool | getEnableBackwardsCompatibility () const
| Gets whether backwards compatibility is enabled.
const String & | getEntryPoint () const
| Gets the entry point defined for this program.
ID3D11GeometryShader * | getGeometryShader () const
ID3D11HullShader * | getHullShader () const
const D3D11_SIGNATURE_PARAMETER_DESC & | getInputParamDesc (size_t index) const
const String & | getLanguage () const override
| Overridden from GpuProgram.
ComPtr< ID3D11InputLayout > | getLayoutForPso (const VertexElement2VecVec &vertexElements)
const MicroCode & | getMicroCode () const
String | getNameForMicrocodeCache ()
size_t | getNumInputs () const
size_t | getNumOutputs () const
const D3D11_SIGNATURE_PARAMETER_DESC & | getOutputParamDesc (size_t index) const
ID3D11PixelShader * | getPixelShader () const
const String & | getPreprocessorDefines () const
| Sets the preprocessor defines use to compile the program.
unsigned int | getSubroutineSlot (const String &subroutineSlotName) const
const String & | getTarget () const
| Gets the shader target to compile down to, e.g.
ID3D11VertexShader * | getVertexShader () const
bool | isSupported () const override
| Overridden from GpuProgram.
void | loadFromSource () override
| Internal load implementation, must be implemented by subclasses.
void | reinterpretGSForStreamOut ()
void | setColumnMajorMatrices (bool columnMajor)
| Sets whether matrix packing in column-major order.
void | setEnableBackwardsCompatibility (bool enableBackwardsCompatibility)
| Sets whether backwards compatibility is enabled.
void | setEntryPoint (const String &entryPoint)
| Sets the entry point for this program ie the first method called.
void | setPreprocessorDefines (const String &defines)
| Sets the preprocessor defines use to compile the program.
void | setTarget (const String &target)
| Sets the shader target to compile down to, e.g.
Public Member Functions inherited from Ogre::HighLevelGpuProgram
| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram () override
GpuProgram * | _getBindingDelegate () override
| Returns the GpuProgram which should be bound to the pipeline.
size_t | calculateSize () const override
| Calculate the size of a resource; this will only be called after 'load'.
GpuProgramParametersSharedPtr | createParameters () override
| Creates a new parameters object compatible with this program definition.
const GpuNamedConstants & | getConstantDefinitions () const override
| Get the full list of GpuConstantDefinition instances.
bool | getEnableIncludeHeader () const
bool | getUseHlmsParser () const
void | setEnableIncludeHeader (bool bEnable)
| Whether we should parse the source code looking for include files and embedding the file.
void | setUseHlmsParser (bool bUse)
| Whether we should run the shader through the Hlms parser.
Public Member Functions inherited from Ogre::GpuProgram
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| ~GpuProgram () override
bool | getBuildParametersFromReflection () const
virtual Vector3 | getComputeGroupDimensions () const
| Returns the number of process groups dispatched by this compute program.
virtual GpuProgramParametersSharedPtr | getDefaultParameters ()
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual ushort | getNumberOfPosesIncluded () const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
uint8 | getNumClipDistances () const
| Retrieves the number of clip distances. See GpuProgram::setNumClipDistances.
virtual bool | getPassFogStates () const
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override)
virtual bool | getPassSurfaceAndLightStates () const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override)
virtual bool | getPassTransformStates () const
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
virtual const String & | getSource () const
| Gets the assembler source for this program.
virtual const String & | getSourceFile () const
| Gets the name of the file used as source for this program.
virtual const String & | getSyntaxCode () const
| Gets the syntax code for this program e.g.
virtual GpuProgramType | getType () const
| Get the program type.
virtual bool | hasCompileError () const
| Did this program encounter a compile error when loading?
virtual bool | hasDefaultParameters () const
| Returns true if default parameters have been set up.
virtual bool | isAdjacencyInfoRequired () const
| Returns whether this geometry program requires adjacency information from the input primitives.
virtual bool | isMorphAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform morph animation.
virtual bool | isPoseAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform pose animation.
virtual bool | isSkeletalAnimationIncluded () const
| Returns whether a vertex program includes the required instructions to perform skeletal animation.
virtual bool | isVertexTextureFetchRequired () const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual bool | isVpAndRtArrayIndexFromAnyShaderRequired () const
| Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | resetCompileError ()
| Reset a compile error if it occurred, allowing the load to be retried.
virtual void | setAdjacencyInfoRequired (bool r)
| Sets whether this geometry program requires adjacency information from the input primitives.
virtual void | setAutoReflectArrayBindingsInRootLayout (bool bReflectArrayRootLayouts)
| Set to true to reflects the shader looking for array bindings (e.g.
void | setBuildParametersFromReflection (bool buildParams)
virtual void | setComputeGroupDimensions (Vector3 dimensions)
| Sets the number of process groups dispatched by this compute program.
virtual void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
virtual void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation.
void | setNumClipDistances (const uint8 numClipDistances)
| Sets the number of clip distances this shader uses.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation.
void | setPrefabRootLayout (const PrefabRootLayout::PrefabRootLayout &prefab)
| Sets a prefab root layout, mostly meant for low level materials (e.g.
virtual void | setReplaceVersionMacro (bool bReplace)
| When true:
virtual void | setRootLayout (GpuProgramType t, const RootLayout &rootLayout)
| Sets a RootLayout programmatically, thus the shader source won't be parsed looking for one We will call validate()
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation.
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
virtual void | setSource (const String &source, const String &debugFilename)
| Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e.
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load)
virtual void | setUniformBlockBinding (const char *blockName, uint32 bindingSlot)
| For GL only. Program must be bound when calling.
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | setVpAndRtArrayIndexFromAnyShaderRequired (bool r)
| Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | unsetRootLayout ()
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual const String & | getGroup () const
| Gets the group which this resource is a member of.
virtual ResourceHandle | getHandle () const
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual const String & | getName () const
| Gets resource name.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getSize () const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isBackgroundLoaded () const
| Returns whether this Resource has been earmarked for background loading.
virtual bool | isLoaded () const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isReloadable () const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
virtual void | touch ()
| 'Touches' the resource to indicate it has been used.
virtual void | unload ()
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Public Attributes
bool | mReinterpretingGS
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Attributes inherited from Ogre::HighLevelGpuProgram
static CmdEnableIncludeHeader | msEnableIncludeHeaderCmd
static CmdUseHlmsParser | msUseHlmsParser

## Detailed Description

Specialization of HighLevelGpuProgram to provide support for D3D11 High-Level Shader Language (HLSL).

Remarks
  Note that the syntax of D3D11 HLSL is identical to nVidia's Cg language, therefore unless you know you will only ever be deploying on Direct3D, or you have some specific reason for not wanting to use the Cg plugin, I suggest you use Cg instead since that can produce programs for OpenGL too.

## Constructor & Destructor Documentation

## ◆ D3D11HLSLProgram()

Ogre::D3D11HLSLProgram::D3D11HLSLProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader,
|  | D3D11Device & | device )

## ◆ ~D3D11HLSLProgram()

Ogre::D3D11HLSLProgram::~D3D11HLSLProgram | ( |  | ) |
| override

## Member Function Documentation

## ◆ buildConstantDefinitions()

void Ogre::D3D11HLSLProgram::buildConstantDefinitions | ( |  | ) | const
| overridevirtual

Build the constant definition map, must be overridden.

Note
  The implementation must fill in the (inherited) mConstantDefs field at a minimum, and if the program requires that parameters are bound using logical parameter indexes then the mFloatLogicalToPhysical and mIntLogicalToPhysical maps must also be populated.

Implements Ogre::HighLevelGpuProgram.

## ◆ CreateComputeShader()

void Ogre::D3D11HLSLProgram::CreateComputeShader | ( |  | ) |

## ◆ CreateDomainShader()

void Ogre::D3D11HLSLProgram::CreateDomainShader | ( |  | ) |

## ◆ CreateGeometryShader()

void Ogre::D3D11HLSLProgram::CreateGeometryShader | ( |  | ) |

## ◆ CreateHullShader()

void Ogre::D3D11HLSLProgram::CreateHullShader | ( |  | ) |

## ◆ createParameters()

GpuProgramParametersSharedPtr Ogre::D3D11HLSLProgram::createParameters | ( |  | ) |
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ CreatePixelShader()

void Ogre::D3D11HLSLProgram::CreatePixelShader | ( |  | ) |

## ◆ CreateVertexShader()

void Ogre::D3D11HLSLProgram::CreateVertexShader | ( |  | ) |

## ◆ getColumnMajorMatrices()

bool Ogre::D3D11HLSLProgram::getColumnMajorMatrices | ( |  | ) | const
| inline

Gets whether matrix packed in column-major order.

## ◆ getCompatibleTarget()

const String & Ogre::D3D11HLSLProgram::getCompatibleTarget | ( |  | ) | const

Gets the shader target promoted to the first compatible, e.g.

'vs_4_0' or 'ps_4_0' if backward compatibility is enabled.

## ◆ getComputeShader()

ID3D11ComputeShader * Ogre::D3D11HLSLProgram::getComputeShader | ( |  | ) | const

## ◆ getConstantBuffers()

void Ogre::D3D11HLSLProgram::getConstantBuffers | ( | ID3D11Buffer ** | buffers,
|  | UINT & | outSlotStart,
|  | UINT & | outNumBuffers,
|  | GpuProgramParametersSharedPtr | params,
|  | uint16 | variabilityMask )

buffers must have a capacity of 2, i.e. ID3D11Buffer *buffers[2];

## ◆ getDomainShader()

ID3D11DomainShader * Ogre::D3D11HLSLProgram::getDomainShader | ( |  | ) | const

## ◆ getEnableBackwardsCompatibility()

bool Ogre::D3D11HLSLProgram::getEnableBackwardsCompatibility | ( |  | ) | const
| inline

Gets whether backwards compatibility is enabled.

## ◆ getEntryPoint()

const String & Ogre::D3D11HLSLProgram::getEntryPoint | ( |  | ) | const
| inline

Gets the entry point defined for this program.

## ◆ getGeometryShader()

ID3D11GeometryShader * Ogre::D3D11HLSLProgram::getGeometryShader | ( |  | ) | const

## ◆ getHullShader()

ID3D11HullShader * Ogre::D3D11HLSLProgram::getHullShader | ( |  | ) | const

## ◆ getInputParamDesc()

const D3D11_SIGNATURE_PARAMETER_DESC & Ogre::D3D11HLSLProgram::getInputParamDesc | ( | size_t | index | ) | const

## ◆ getLanguage()

const String & Ogre::D3D11HLSLProgram::getLanguage | ( |  | ) | const
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ getLayoutForPso()

ComPtr< ID3D11InputLayout > Ogre::D3D11HLSLProgram::getLayoutForPso | ( | const VertexElement2VecVec & | vertexElements | ) |

## ◆ getMicroCode()

const MicroCode & Ogre::D3D11HLSLProgram::getMicroCode | ( |  | ) | const

## ◆ getNameForMicrocodeCache()

String Ogre::D3D11HLSLProgram::getNameForMicrocodeCache | ( |  | ) |

## ◆ getNumInputs()

size_t Ogre::D3D11HLSLProgram::getNumInputs | ( |  | ) | const

## ◆ getNumOutputs()

size_t Ogre::D3D11HLSLProgram::getNumOutputs | ( |  | ) | const

## ◆ getOutputParamDesc()

const D3D11_SIGNATURE_PARAMETER_DESC & Ogre::D3D11HLSLProgram::getOutputParamDesc | ( | size_t | index | ) | const

## ◆ getPixelShader()

ID3D11PixelShader * Ogre::D3D11HLSLProgram::getPixelShader | ( |  | ) | const

## ◆ getPreprocessorDefines()

const String & Ogre::D3D11HLSLProgram::getPreprocessorDefines | ( |  | ) | const
| inline

Sets the preprocessor defines use to compile the program.

## ◆ getSubroutineSlot()

unsigned int Ogre::D3D11HLSLProgram::getSubroutineSlot | ( | const String & | subroutineSlotName | ) | const

## ◆ getTarget()

const String & Ogre::D3D11HLSLProgram::getTarget | ( |  | ) | const
| inline

Gets the shader target to compile down to, e.g.

'vs_1_1'.

## ◆ getVertexShader()

ID3D11VertexShader * Ogre::D3D11HLSLProgram::getVertexShader | ( |  | ) | const

## ◆ isSupported()

bool Ogre::D3D11HLSLProgram::isSupported | ( |  | ) | const
| overridevirtual

Overridden from GpuProgram.

Reimplemented from Ogre::GpuProgram.

## ◆ loadFromSource()

void Ogre::D3D11HLSLProgram::loadFromSource | ( |  | ) |
| overridevirtual

Internal load implementation, must be implemented by subclasses.

Implements Ogre::GpuProgram.

## ◆ reinterpretGSForStreamOut()

void Ogre::D3D11HLSLProgram::reinterpretGSForStreamOut | ( |  | ) |

## ◆ setColumnMajorMatrices()

void Ogre::D3D11HLSLProgram::setColumnMajorMatrices | ( | bool | columnMajor | ) |
| inline

Sets whether matrix packing in column-major order.

## ◆ setEnableBackwardsCompatibility()

void Ogre::D3D11HLSLProgram::setEnableBackwardsCompatibility | ( | bool | enableBackwardsCompatibility | ) |
| inline

Sets whether backwards compatibility is enabled.

## ◆ setEntryPoint()

void Ogre::D3D11HLSLProgram::setEntryPoint | ( | const String & | entryPoint | ) |
| inline

Sets the entry point for this program ie the first method called.

## ◆ setPreprocessorDefines()

void Ogre::D3D11HLSLProgram::setPreprocessorDefines | ( | const String & | defines | ) |
| inline

Sets the preprocessor defines use to compile the program.

## ◆ setTarget()

void Ogre::D3D11HLSLProgram::setTarget | ( | const String & | target | ) |

Sets the shader target to compile down to, e.g.

'vs_1_1'.

## Member Data Documentation

## ◆ mReinterpretingGS

bool Ogre::D3D11HLSLProgram::mReinterpretingGS

The documentation for this class was generated from the following file:

- OgreD3D11HLSLProgram.h